OpenTTD Source: StationResolverObject Struct Reference

OpenTTD Source 13.1

Public Member Functions | Data Fields
StationResolverObject Struct Reference

Station resolver. More...

`#include <newgrf_station.h>`

Inheritance diagram for StationResolverObject:

## Public Member Functions
| StationResolverObject (const StationSpec *statspec, BaseStation *st, TileIndex tile, CallbackID callback=CBID_NO_CALLBACK, uint32 callback_param1=0, uint32 callback_param2=0)
| Resolver for stations. More...
TownScopeResolver * | GetTown ()
| Get the town scope associated with a station, if it exists. More...
ScopeResolver * | GetScope (VarSpriteGroupScope scope=VSG_SCOPE_SELF, byte relative=0) override
| Get a resolver for the scope. More...
const SpriteGroup * | ResolveReal (const RealSpriteGroup *group) const override
| Get the real sprites of the grf. More...
GrfSpecFeature | GetFeature () const override
| Get the feature number being resolved for. More...
uint32 | GetDebugID () const override
| Get an identifier for the item being resolved. More...
Public Member Functions inherited from ResolverObject
| ResolverObject (const GRFFile *grffile, CallbackID callback=CBID_NO_CALLBACK, uint32 callback_param1=0, uint32 callback_param2=0)
| Resolver constructor. More...
const SpriteGroup * | Resolve ()
| Resolve SpriteGroup. More...
uint16 | ResolveCallback ()
| Resolve callback. More...
uint32 | GetRemainingTriggers () const
| Returns the waiting triggers that did not trigger any rerandomisation.
uint32 | GetReseedSum () const
| Returns the OR-sum of all bits that need reseeding independent of the scope they were accessed with. More...
void | ResetState ()
| Resets the dynamic state of the resolver object. More...

## Data Fields
StationScopeResolver | station_scope
| The station scope resolver.
TownScopeResolver * | town_scope
| The town scope resolver (created on the first call).
Data Fields inherited from ResolverObject
ScopeResolver | default_scope
| Default implementation of the grf scope.
CallbackID | callback
| Callback being resolved.
uint32 | callback_param1
| First parameter (var 10) of the callback.
uint32 | callback_param2
| Second parameter (var 18) of the callback.
uint32 | last_value
| Result of most recent DeterministicSpriteGroup (including procedure calls)
uint32 | waiting_triggers
| Waiting triggers to be used by any rerandomisation. (scope independent)
uint32 | used_triggers
| Subset of cur_triggers, which actually triggered some rerandomisation. (scope independent)
uint32 | reseed [VSG_END]
| Collects bits to rerandomise while triggering triggers.
const GRFFile * | grffile
| GRFFile the resolved SpriteGroup belongs to.
const SpriteGroup * | root_spritegroup
| Root SpriteGroup to use for resolving.

## Detailed Description

Station resolver.

Definition at line 50 of file newgrf_station.h.

## Constructor & Destructor Documentation

## ◆ StationResolverObject()

StationResolverObject::StationResolverObject | ( | const StationSpec * | statspec,
|  | BaseStation * | base_station,
|  | TileIndex | tile,
|  | CallbackID | callback = `CBID_NO_CALLBACK`,
|  | uint32 | callback_param1 = `0`,
|  | uint32 | callback_param2 = `0`
| ) |  |

Resolver for stations.

Parameters

  statspec | Station (type) specification.
  base_station | Instance of the station.
  tile | Tile of the station.
  callback | Callback ID.
  callback_param1 | First parameter (var 10) of the callback.
  callback_param2 | Second parameter (var 18) of the callback.

Definition at line 559 of file newgrf_station.cpp.

References _svc.

## Member Function Documentation

## ◆ GetDebugID()

uint32 StationResolverObject::GetDebugID | ( |  | ) | const
| overridevirtual

Get an identifier for the item being resolved.

This function is mainly intended for the callback profiling feature, and should return an identifier recognisable by the NewGRF developer.

Reimplemented from ResolverObject.

Definition at line 545 of file newgrf_station.cpp.

References StationSpec::grf_prop, GRFFilePropsBase< Tcnt >::local_id, station_scope, and StationScopeResolver::statspec.

## ◆ GetFeature()

GrfSpecFeature StationResolverObject::GetFeature | ( |  | ) | const
| overridevirtual

Get the feature number being resolved for.

This function is mainly intended for the callback profiling feature.

Reimplemented from ResolverObject.

Definition at line 540 of file newgrf_station.cpp.

## ◆ GetScope()

ScopeResolver* StationResolverObject::GetScope | ( | VarSpriteGroupScope | scope = `VSG_SCOPE_SELF`,
|  | byte | relative = `0`
| ) |  |
| inlineoverridevirtual

Get a resolver for the scope.

Parameters

  scope | Scope to return.
  relative | Additional parameter for VSG_SCOPE_RELATIVE.

Returns
  The resolver for the requested scope.

Reimplemented from ResolverObject.

Definition at line 60 of file newgrf_station.h.

References ResolverObject::GetScope(), GetTown(), station_scope, VSG_SCOPE_PARENT, and VSG_SCOPE_SELF.

## ◆ GetTown()

TownScopeResolver * StationResolverObject::GetTown | ( |  | ) |

Get the town scope associated with a station, if it exists.

On the first call, the town scope is created (if possible).

Returns
  Town scope, if available.

Definition at line 256 of file newgrf_station.cpp.

References ClosestTownFromTile(), INVALID_TILE, StationScopeResolver::st, station_scope, StationScopeResolver::tile, BaseStation::town, and town_scope.

Referenced by GetScope().

## ◆ ResolveReal()

const SpriteGroup * StationResolverObject::ResolveReal | ( | const RealSpriteGroup * | group | ) | const
| overridevirtual

Get the real sprites of the grf.

Parameters

  group | Group to get.

Returns
  The available sprite group.

Reimplemented from ResolverObject.

Definition at line 495 of file newgrf_station.cpp.

References StationScopeResolver::cargo_type, CT_INVALID, SpecializedStation< Station, false >::From(), RealSpriteGroup::loading, StationScopeResolver::st, STAT_CLASS_WAYP, and station_scope.

The documentation for this struct was generated from the following files:

- src/newgrf_station.h
- src/newgrf_station.cpp